var logTarget = document.getElementById('log');
function log(msg) {
  if (!logTarget) {
    return;
  }

  console.debug(msg);
  logTarget.textContent = msg;
}

var settings = null;
function loadSettings(next) {
  settings = {
    "mozSettingsAPI.testingValue": true 
  };
  next();
  return;

  var xhr = new XMLHttpRequest();
  xhr.open('GET', '/common-settings.json', true);
  xhr.onreadystatechange = function(evt) {
    var status, err;
    if (xhr.readyState === 4) {
      status = xhr.status;
      if (status > 399 && status < 600) {
        //An http 4xx or 5xx error. Signal an error.
        err = new Error(url + ' HTTP status: ' + status);
        log(err);
      } else {
        log("Received settings");
        settings = JSON.parse(xhr.responseText);
        next();
      }
    }
  };
  xhr.send(null);
}

function settingsObserver(obj) {
  log("Setting '" + obj.settingName + "' changed to '" + obj.settingValue + "'");
}

function getRandomInt(min, max) {
  return Math.floor(Math.random() * (max - min)) + min;
}

function triggerMutation(name) {
  var timeout = getRandomInt(1, 9) * 1000;
  var newvalue;
  var cvalue = settings[name];
  var ctype = typeof settings[name];
  switch (ctype) {
    case 'boolean':
      newvalue = !cvalue;
      break;
    default:
      // console.debug("Unhandled type: " + ctype);
      break;
  }

  var payload = {};
  payload[name] = newvalue;

  // log("Changing '" + name + "' from '" + cvalue + "' to '" + newvalue + "' in the next " + timeout + "ms");
  setTimeout(function() {
    // log("!!! DOING !!! " + JSON.stringify(payload) + " !!!");
    var lockset = navigator.mozSettings.createLock();
    var reqset = lockset.set(payload);
    settings[name] = newvalue;
    reqset.onsuccess = function(evt) {
      // log("SET Lock finished: " + JSON.stringify(reqset.result));
      var reqget = navigator.mozSettings.createLock().get('*');
      window.location = '/index.html';
      reqget.onsuccess = function(evt) {
        var v = reqget.result[name];
        // log("GET Lock finished: " + JSON.stringify(v));
        // settings[name] = reqget.result[name];
      };
      reqget.onerror = function(err) {
        log("GET Lock finished with err: " + JSON.stringify(err));
      };
    };
    reqset.onerror = function(err) {
      log("SET Lock finished with err: " + JSON.stringify(err));
    };
  }, timeout);
}

function triggerMutations() {
  log("In triggerMutations");
  for (var key of Object.keys(settings)) {
    // log("In triggerMutations for: " + key);
    triggerMutation(key);
  }
}

function startMutations() {
  log("In startMutations()");
  setTimeout(function() {
    log("Calling triggerMutations()");
    triggerMutations();
    startMutations();
  }, 2000);
}

function addObservers() {
  log("In addObservers()");
  for (var key of Object.keys(settings)) {
    // log('Adding observer for: ' + key);
    navigator.mozSettings.addObserver(key, settingsObserver);
  }
}

function start() {
  log("Calling startMutations()");
  addObservers();
  startMutations();
}

window.addEventListener('load', function() {
  log('Loading app');
  loadSettings(start);
});
